﻿package  
{
	import flash.display.Sprite;
	import org.papervision3d.lights.PointLight3D;
	import org.papervision3d.materials.ColorMaterial;
	import org.papervision3d.materials.utils.MaterialsList;
	import org.papervision3d.objects.primitives.Cube;
	import org.papervision3d.objects.primitives.Sphere;
	import org.papervision3d.scenes.Scene3D;
	
	public class RubicCube extends Sprite
	{
		
	static internal const GRAY:int = -1;
	static internal const YELLOW:int = 0;
	static internal const WHITE:int = 1;
	static internal const RED:int = 2;
	static internal const ORANGE:int = 3;
	static internal const GREEN:int = 4;
	static internal const BLUE:int = 5;

	static internal var cube:Array;
	static internal var sheel:Array;
	
	static internal var bg:Sphere;
	
	static internal var colorGroup:Array;
	
	
	
		public function RubicCube() 
		{
		
			colorGroup = new Array();
			
			for (var i:uint = 0; i < 6; i++)
				colorGroup[i] = new Array();
		}
		
		static internal function decide_next_operation():int {			
			return Math.floor(Math.random() * 6);
		}


		static internal function get3Darray():Array {

			var obj:Array = new Array();
	
			for (var i:uint = 0; i < 3; i++ ) {
				obj[i] = new Array();
				
				for (var j:uint = 0; j < 3; j++ )
					obj[i][j] = new Array();				
			}

			return obj;
		}

		static internal function get3Darray6():Array {

			var obj:Array = new Array();
	
			for (var i:uint = 0; i < 6; i++ ) {
				obj[i] = new Array();
				
				for (var j:uint = 0; j < 3; j++ )
					obj[i][j] = new Array();				
			}

			return obj;
		}


		static internal function make_base(base:Array):void  {

			var size:Number = 50;
			
			var gray:ColorMaterial = RubicCube.set_color(RubicCube.GRAY);

			for(var i:int = 0; i < 3; i++)
				for(var j:int = 0; j < 3; j++)
					for(var k:int = 0; k < 3; k++){
						base[i][j][k] = new Cube(new MaterialsList( { all : gray } ), size - 30, size - 30, size - 30);
						base[i][j][k].x += (i - 1) * size;
						base[i][j][k].y += (j - 1) * size;
						base[i][j][k].z += -(k - 1) * size;
					}
		}


		static internal function set_color(color:int):ColorMaterial {

			var mat:ColorMaterial;

			var alpha:Number = 0.5;
			
		switch(color) {
		case RubicCube.YELLOW:
			mat = new ColorMaterial(0xffff00, alpha);
			break;
		case RubicCube.WHITE:
			mat = new ColorMaterial(0xffffff, alpha);
			break;
		case RubicCube.RED:
			mat = new ColorMaterial(0xff0000, alpha);
			break;
		case RubicCube.ORANGE:
			mat = new ColorMaterial(0xff8800, alpha);
			break;
		case RubicCube.GREEN:
			mat = new ColorMaterial(0x00ff00, alpha);
			break;
		case RubicCube.BLUE:
			mat = new ColorMaterial(0x0000ff, alpha);
			break;
		case RubicCube.GRAY:
			mat = new ColorMaterial(0x555555, alpha);
			break;
		default:
			mat = new ColorMaterial(0x000000, alpha);
		}

		return mat;
	}

		
	static internal function set_cube(tg:Sphere, base:Array):void{

		RubicCube.cube = get3Darray();
		RubicCube.set_center(tg, base);
		RubicCube.set_edge(tg, base);
		RubicCube.set_corner(tg, base);

	}


	
	static internal function make_cube(tg:Sphere):void{

		var base:Array = get3Darray();
		sheel = get3Darray6();
		

		RubicCube.make_base(base);
		RubicCube.make_sheel();
		RubicCube.set_cube(tg, base);


	}


	static internal function make_sheel():void {

		var size:Number = 30;
		var thickness:Number = 2;
		var surface:Number = 50;//50
		
		var b:Number = 1.5;//1.5

		Sheel.init_interpol();

		
		var yellow:ColorMaterial = RubicCube.set_color(RubicCube.YELLOW);
		var white:ColorMaterial = RubicCube.set_color(RubicCube.WHITE);
		var red:ColorMaterial = RubicCube.set_color(RubicCube.RED);
		var orange:ColorMaterial = RubicCube.set_color(RubicCube.ORANGE);
		var green:ColorMaterial = RubicCube.set_color(RubicCube.GREEN);
		var blue:ColorMaterial = RubicCube.set_color(RubicCube.BLUE);

		for(var i:int = 0; i < 3; i++)
			for(var j:int = 0; j < 3; j++){
				RubicCube.sheel[RubicCube.YELLOW][i][j] = new Sheel(size, thickness, size, yellow, RubicCube.YELLOW);
				RubicCube.sheel[RubicCube.YELLOW][i][j].mulTranslation((i - 1) * surface, (j - 1) * surface, -surface * b);
			}

		for(i = 0; i < 3; i++)
			for(j = 0; j < 3; j++){
				RubicCube.sheel[RubicCube.WHITE][i][j] = new Sheel(size, size, thickness, white, RubicCube.WHITE);
				RubicCube.sheel[RubicCube.WHITE][i][j].mulTranslation((i - 1) * surface, surface * b, -(j - 1) * surface);
			}

		for(i = 0; i < 3; i++)
			for(j = 0; j < 3; j++){
				RubicCube.sheel[RubicCube.RED][i][j] = new Sheel(thickness, size, size, red, RubicCube.RED);
				RubicCube.sheel[RubicCube.RED][i][j].mulTranslation(-surface * b, (i - 1) * surface, -(j - 1) * surface);
			}

		for(i = 0; i < 3; i++)
			for(j = 0; j < 3; j++){
				RubicCube.sheel[RubicCube.ORANGE][i][j] = new Sheel(thickness, size, size, orange, RubicCube.ORANGE);
				RubicCube.sheel[RubicCube.ORANGE][i][j].mulTranslation(surface * b, (i - 1) * surface, -(j - 1) * surface);
			}

		for(i = 0; i < 3; i++)
			for(j = 0; j < 3; j++){
				RubicCube.sheel[RubicCube.GREEN][i][j] = new Sheel(size, thickness, size, green, RubicCube.GREEN);
				RubicCube.sheel[RubicCube.GREEN][i][j].mulTranslation((i - 1) * surface, (j - 1) * surface, surface * b);
			}

		for(i = 0; i < 3; i++)
			for(j = 0; j < 3; j++){
				RubicCube.sheel[RubicCube.BLUE][i][j] = new Sheel(size, size, thickness, blue, RubicCube.BLUE);
				RubicCube.sheel[RubicCube.BLUE][i][j].mulTranslation((i - 1) * surface, -surface * b, -(j - 1) * surface);
			}
	}

	
	static internal function set_edge(tg:Sphere, base:Array):void {

		var sheel_vector:Array = new Array(12);

		for(var i:int = 0; i < 12; i++)
			sheel_vector[i] = new Array(CubeUnit.EDGE);

		sheel_vector[0][0] = RubicCube.sheel[RubicCube.YELLOW][1][2];
		sheel_vector[0][1] = RubicCube.sheel[RubicCube.WHITE][1][2];
		RubicCube.cube[1][2][2] = new CubeUnit(tg, CubeUnit.EDGE, base[1][2][2], sheel_vector[0]);

		sheel_vector[1][0] = RubicCube.sheel[RubicCube.YELLOW][0][1];
		sheel_vector[1][1] = RubicCube.sheel[RubicCube.RED][1][2];
		RubicCube.cube[0][1][2] = new CubeUnit(tg, CubeUnit.EDGE, base[0][1][2], sheel_vector[1]);

		sheel_vector[2][0] = RubicCube.sheel[RubicCube.YELLOW][2][1];
		sheel_vector[2][1] = RubicCube.sheel[RubicCube.ORANGE][1][2];
		RubicCube.cube[2][1][2] = new CubeUnit(tg, CubeUnit.EDGE, base[2][1][2], sheel_vector[2]);

		sheel_vector[3][0] = RubicCube.sheel[RubicCube.YELLOW][1][0];
		sheel_vector[3][1] = RubicCube.sheel[RubicCube.BLUE][1][2];
		RubicCube.cube[1][0][2] = new CubeUnit(tg, CubeUnit.EDGE, base[1][0][2], sheel_vector[3]);

		sheel_vector[4][0] = RubicCube.sheel[RubicCube.GREEN][1][2];
		sheel_vector[4][1] = RubicCube.sheel[RubicCube.WHITE][1][0];
		RubicCube.cube[1][2][0] = new CubeUnit(tg, CubeUnit.EDGE, base[1][2][0], sheel_vector[4]);

		sheel_vector[5][0] = RubicCube.sheel[RubicCube.GREEN][0][1];
		sheel_vector[5][1] = RubicCube.sheel[RubicCube.RED][1][0];
		RubicCube.cube[0][1][0] = new CubeUnit(tg, CubeUnit.EDGE, base[0][1][0], sheel_vector[5]);

		sheel_vector[6][0] = RubicCube.sheel[RubicCube.GREEN][2][1];
		sheel_vector[6][1] = RubicCube.sheel[RubicCube.ORANGE][1][0];
		RubicCube.cube[2][1][0] = new CubeUnit(tg, CubeUnit.EDGE, base[2][1][0], sheel_vector[6]);

		sheel_vector[7][0] = RubicCube.sheel[RubicCube.GREEN][1][0];
		sheel_vector[7][1] = RubicCube.sheel[RubicCube.BLUE][1][0];
		RubicCube.cube[1][0][0] = new CubeUnit(tg, CubeUnit.EDGE, base[1][0][0], sheel_vector[7]);

		sheel_vector[8][0] = RubicCube.sheel[RubicCube.WHITE][0][1];
		sheel_vector[8][1] = RubicCube.sheel[RubicCube.RED][2][1];
		RubicCube.cube[0][2][1] = new CubeUnit(tg, CubeUnit.EDGE, base[0][2][1], sheel_vector[8]);

		sheel_vector[9][0] = RubicCube.sheel[RubicCube.WHITE][2][1];
		sheel_vector[9][1] = RubicCube.sheel[RubicCube.ORANGE][2][1];
		RubicCube.cube[2][2][1] = new CubeUnit(tg, CubeUnit.EDGE, base[2][2][1], sheel_vector[9]);

		sheel_vector[10][0] = RubicCube.sheel[RubicCube.BLUE][0][1];
		sheel_vector[10][1] = RubicCube.sheel[RubicCube.RED][0][1];
		RubicCube.cube[0][0][1] = new CubeUnit(tg, CubeUnit.EDGE, base[0][0][1], sheel_vector[10]);

		sheel_vector[11][0] = RubicCube.sheel[RubicCube.ORANGE][0][1];
		sheel_vector[11][1] = RubicCube.sheel[RubicCube.BLUE][2][1];
		RubicCube.cube[2][0][1] = new CubeUnit(tg, CubeUnit.EDGE, base[2][0][1], sheel_vector[11]);

	}
	

	
	static internal function set_corner(tg:Sphere, base:Array):void {
		
		
		var sheel_vector:Array = new Array(8);

		for(var i:int = 0; i < 8; i++)
			sheel_vector[i] = new Array(CubeUnit.CORNER);

		sheel_vector[0][0] = RubicCube.sheel[RubicCube.YELLOW][0][2];
		sheel_vector[0][1] = RubicCube.sheel[RubicCube.WHITE][0][2];
		sheel_vector[0][2] = RubicCube.sheel[RubicCube.RED][2][2];
		RubicCube.cube[0][2][2] = new CubeUnit(tg, CubeUnit.CORNER, base[0][2][2], sheel_vector[0]);

		sheel_vector[1][0] = RubicCube.sheel[RubicCube.YELLOW][2][2];
		sheel_vector[1][1] = RubicCube.sheel[RubicCube.ORANGE][2][2];
		sheel_vector[1][2] = RubicCube.sheel[RubicCube.WHITE][2][2];
		RubicCube.cube[2][2][2] = new CubeUnit(tg, CubeUnit.CORNER, base[2][2][2], sheel_vector[1]);

		sheel_vector[2][0] = RubicCube.sheel[RubicCube.YELLOW][0][0];
		sheel_vector[2][1] = RubicCube.sheel[RubicCube.RED][0][2];
		sheel_vector[2][2] = RubicCube.sheel[RubicCube.BLUE][0][2];
		RubicCube.cube[0][0][2] = new CubeUnit(tg, CubeUnit.CORNER, base[0][0][2], sheel_vector[2]);

		sheel_vector[3][0] = RubicCube.sheel[RubicCube.YELLOW][2][0];
		sheel_vector[3][1] = RubicCube.sheel[RubicCube.ORANGE][0][2];
		sheel_vector[3][2] = RubicCube.sheel[RubicCube.BLUE][2][2];
		RubicCube.cube[2][0][2] = new CubeUnit(tg, CubeUnit.CORNER, base[2][0][2], sheel_vector[3]);

		sheel_vector[4][0] = RubicCube.sheel[RubicCube.GREEN][0][2];
		sheel_vector[4][1] = RubicCube.sheel[RubicCube.WHITE][0][0];
		sheel_vector[4][2] = RubicCube.sheel[RubicCube.RED][2][0];
		RubicCube.cube[0][2][0] = new CubeUnit(tg, CubeUnit.CORNER, base[0][2][0], sheel_vector[4]);

		sheel_vector[5][0] = RubicCube.sheel[RubicCube.GREEN][2][2];
		sheel_vector[5][1] = RubicCube.sheel[RubicCube.ORANGE][2][0];
		sheel_vector[5][2] = sheel[RubicCube.WHITE][2][0];
		RubicCube.cube[2][2][0] = new CubeUnit(tg, CubeUnit.CORNER, base[2][2][0], sheel_vector[5]);

		sheel_vector[6][0] = sheel[RubicCube.GREEN][0][0];
		sheel_vector[6][1] = sheel[RubicCube.RED][0][0];
		sheel_vector[6][2] = sheel[RubicCube.BLUE][0][0];
		RubicCube.cube[0][0][0] = new CubeUnit(tg, CubeUnit.CORNER, base[0][0][0], sheel_vector[6]);

		sheel_vector[7][0] = sheel[RubicCube.GREEN][2][0];
		sheel_vector[7][1] = sheel[RubicCube.ORANGE][0][0];
		sheel_vector[7][2] = sheel[RubicCube.BLUE][2][0];
		RubicCube.cube[2][0][0] = new CubeUnit(tg, CubeUnit.CORNER, base[2][0][0], sheel_vector[7]);


	}

	
	static internal function set_center(tg:Sphere, base:Array):void {
				
		var sheel_vector:Array = new Array(6);

		for(var i:int = 0; i < 6; i++)
			sheel_vector[i] = new Array(CubeUnit.CENTER);

		sheel_vector[0][0] = RubicCube.sheel[RubicCube.YELLOW][1][1];
		RubicCube.cube[1][1][2] = new CubeUnit(tg, CubeUnit.CENTER, base[1][1][2], sheel_vector[0]);

		sheel_vector[1][0] = RubicCube.sheel[RubicCube.WHITE][1][1];
		RubicCube.cube[1][2][1] = new CubeUnit(tg, CubeUnit.CENTER, base[1][2][1], sheel_vector[1]);

		sheel_vector[2][0] = RubicCube.sheel[RubicCube.RED][1][1];
		RubicCube.cube[0][1][1] = new CubeUnit(tg, CubeUnit.CENTER, base[0][1][1], sheel_vector[2]);

		sheel_vector[3][0] = RubicCube.sheel[RubicCube.ORANGE][1][1];
		RubicCube.cube[2][1][1] = new CubeUnit(tg, CubeUnit.CENTER, base[2][1][1], sheel_vector[3]);

		sheel_vector[4][0] = RubicCube.sheel[RubicCube.GREEN][1][1];
		RubicCube.cube[1][1][0] = new CubeUnit(tg, CubeUnit.CENTER, base[1][1][0], sheel_vector[4]);

		sheel_vector[5][0] = RubicCube.sheel[RubicCube.BLUE][1][1];
		RubicCube.cube[1][0][1] = new CubeUnit(tg, CubeUnit.CENTER, base[1][0][1], sheel_vector[5]);
	}

	
	
	static internal function get_color_name(color:int):String {

		var color_name:String;

		switch(color) {
		case RubicCube.YELLOW:
			color_name = "YELLOW";
			break;
		case RubicCube.WHITE:
			color_name = "WHITE";
			break;
		case RubicCube.RED:
			color_name = "RED";
			break;
		case RubicCube.ORANGE:
			color_name = "ORANGE";
			break;
		case RubicCube.GREEN:
			color_name = "GREEN";
			break;
		case RubicCube.BLUE:
			color_name = "BLUE";
			break;
		default:
			color_name = "GRAY";
		}

		return color_name;
	}

	
	}
	
}


